<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: index.php 478 2010-10-18 12:41:03Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

include "includes/commons.inc.php";
require_once PHPDISK_ROOT.'includes/upload.func.php';
require_once PHPDISK_ROOT.'includes/image.func.php';

$in_front = true;

require_once lang('index');

$lang = array_merge($pub_lang,$lang);
$title = $settings['site_title'];
include PHPDISK_ROOT."./includes/header.inc.php";

$last = $db->fetch_one_array("select userid,username from {$tpf}users order by userid desc limit 1");
$last['username_all'] = $last['username'];
$last['username'] = cutstr($last['username'],18);
$a_last_user = urr("space","username=".rawurlencode($last['username_all']));

$rs = $db->fetch_one_array("select wealth,credit,rank,exp from {$tpf}users where userid='$pd_uid' limit 1");
if($rs){
	$credit = (int)$rs['credit'];
	$wealth = (int)$rs['wealth'];
	$rank = (int)$rs['rank'];
	$exp = (int)$rs['exp'];
	$this_exp = ($rank+1)*$settings['exp_const'];
	$lv_tips = ($rank+1)*$settings['exp_const']-$exp;
	$exp_fill = @round(100*($exp/(($rank+1)*$settings['exp_const'])));
}
unset($rs);

if($pd_uid){
	$stats['total_folders'] = (int)@$db->result_first("select count(*) from {$tpf}folders where userid='$pd_uid' and in_recycle=0");
	$stats['total_share_files'] = @$db->result_first("select count(*) from {$tpf}files where userid='$pd_uid' and in_share=1 and in_recycle=0");
	$stats['total_files'] = (int)@$db->result_first("select count(*) from {$tpf}files where userid='$pd_uid' and in_recycle=0");
	$stats['file_size_total'] = get_size(@$db->result_first("select sum(file_size) from {$tpf}files where userid='$pd_uid' and in_recycle=0"));
	$stats['last_login_ip'] = @$db->result_first("select last_login_ip from {$tpf}users where userid='$pd_uid'");
}

@set_time_limit(0);
$upload_max = get_byte_value(ini_get('upload_max_filesize'));
$post_max = get_byte_value(ini_get('post_max_size'));
$settings_max = $settings['max_file_size'] ? get_byte_value($settings['max_file_size']) : 0;
$max_php_file_size = min($upload_max, $post_max);
$max_file_size_byte = ($settings_max && $settings_max <= $max_php_file_size) ? $settings_max : $max_php_file_size;
$max_user_file_size = get_size($max_file_size_byte,'B',0);

switch($action){
	default:
		if($task =='guest_upload'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			if(!display_plugin('guest_upload','open_guest_upload_plugin',$settings['open_guest_upload'],0)){
				exit('ERROR: guest_upload'.$lang['plugin_not_install']);
			}
			
			$vis_file = array();
			
			if(isset($_FILES['vis_file']) && is_array($_FILES['vis_file'])){
				foreach($_FILES['vis_file'] as $key => $var){
					foreach($var as $id => $val) {
						$vis_file[$id][$key] = $val;
					}
				}
			}
			if($vis_file){
				foreach($vis_file as $k => $file) {
					create_store_dir();
					$file_real_path = PHPDISK_ROOT.'/'.$settings['file_path'].'/';
					$file_store_path = short_date("Y").'/'.short_date("m").'/'.short_date("d").'/';
					
					if(!is_utf8()){
						$file['name'] = convert_str('utf-8','gbk',$file['name']);
					}
					$file_extension = $db->escape(get_extension($file['name']));
					$esp = strlen($file_extension)+1;
					if($file_extension){
						$file_name = $db->escape(substr($file['name'],0,strlen($file['name'])-$esp));
					}else{
						$file_name = $db->escape($file['name']);
					}
					$file_real_name = $settings['store_true_filename'] ? $file_name : md5(uniqid(mt_rand(),true).microtime());
					$file_real_name_store = is_utf8() ? convert_str('utf-8','gbk',$file_real_name) : $file_real_name;
					$file_ext = get_real_ext($file_extension);
					$dest_file = $file_real_path.$file_store_path.$file_real_name_store.$file_ext;
					
					if($max_file_size_byte<$file['size']){
						$error = true;
						$sysmsg[] = $lang['file_size_too_big'];
					}
					
					if(!$error && upload_file($file['tmp_name'],$dest_file)){

						$file_key = random(8);
						
						$file_mime = strtolower($db->escape($file['type']));
						$img_arr = getimagesize($dest_file);
						if($img_arr[2] && @in_array($file_extension,array('jpg','jpeg','png','gif','bmp'))){
							make_thumb($dest_file, $file_real_path.$file_store_path.$file_real_name_store.'_thumb.'.$file_extension,$settings['thumb_width'],$settings['thumb_height']);
							$is_image = 1;
						}else{
							$is_image = 0;
						}
						$thumb_size = 0;
						$in_share = 1;
						$is_checked = $settings['check_guest_upload'] ? 0 : 1;
		
						$ins = array(
							'file_name' => $file_name,
							'file_key' => $file_key,
							'file_extension' => $file_extension,
							'is_image' => $is_image,
							'file_mime' => $file_mime,
							'file_description' => $file_description ? $file_description : '',
							'file_store_path' => $file_store_path,
							'file_real_name' => $file_real_name,
							'file_md5' => $file_md5 ? $file_md5 : '',
							'server_oid' => $group_set['server_ids'] ? (int)$group_set['server_ids'] : 1,
							'file_size' => $file['size'],
							'thumb_size' => $thumb_size,
							'file_time' => $timestamp,
							'is_checked' => $is_checked,
							'ip' => $onlineip,
						);
						$db->query_unbuffered("insert into {$tpf}files set ".$db->sql_array($ins).";");
						
						$sysmsg = $lang['visitor_upload_success'];
						redirect('./',$sysmsg);
					}else{
						redirect('./',$sysmsg);
					}
				}
			}

		}else{
			$settings['guest_file_show_num'] = $settings['guest_file_show_num'] ? (int)$settings['guest_file_show_num'] : 10;
			$q = $db->query("select file_id,file_name,file_size,file_time,file_extension,file_key from {$tpf}files where userid=0 and ip='$onlineip' order by file_id desc limit {$settings['guest_file_show_num']}");
			$guest_arr = array();
			while($rs = $db->fetch_array($q)){
				$tmp_ext = $rs['file_extension'] ? '.'.$rs['file_extension'] : "";
				$rs['file_name'] = $rs['file_name'].$tmp_ext;
				$rs['file_size'] = get_size($rs['file_size']);
				$rs['file_time'] = custom_time("Y-m-d",$rs['file_time']);
				$rs['a_viewfile'] = urr("viewfile","file_id={$rs['file_id']}");
				$guest_arr[] = $rs;
			}
			$db->free($q);
			unset($rs);
			$settings['guest_upload_max'] = $settings['guest_upload_max'] ? (int)$settings['guest_upload_max'] : 3;
			require_once template_echo('phpdisk',TPL_NAME);
		}
}
guest_upload_auto_delete();
include PHPDISK_ROOT."./includes/footer.inc.php";

?>