<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: payment.php 451 2010-10-02 08:35:14Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

include "includes/commons.inc.php";

$in_front = true;

require_once lang('payment');

$lang = array_merge($pub_lang,$lang);
if(!display_plugin('payment','open_payment_plugin',$settings['open_payment'],0)){
	exit('ERROR: payment '.$lang['plugin_not_install']);
}

$title = $lang['pay_online'];
include PHPDISK_ROOT."./includes/header.inc.php";

switch($action){
	case 'alipay':
		include_once PD_PLUGINS_DIR."payment/alipay/alipay_notify.php";
		include_once PD_PLUGINS_DIR."payment/alipay/alipay_config.php";
		
		$alipay = new alipay_notify($partner,$security_code,$sign_type,$_input_charset,$transport);
		$verify_result = $alipay->return_verify();
		
		$out_trade_no = trim(gpc('out_trade_no','G',''));
		$total_fee = (float)gpc('total_fee','G','');
		$auto_convert = (int)gpc('auto_convert','G',0);
		 
		if($verify_result) {
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$out_trade_no' and pay_method='$action' and userid='$pd_uid'");
			if($rs['total']){
				$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
			}else{
				$ins = array(
					'pay_method' => $action,
					'userid' => $pd_uid,
					'order_number' => $db->escape($out_trade_no),
					'total_fee' => $total_fee,
					'pay_status' => 'success',
					'in_time' => $timestamp,
					'ip' => $onlineip,
				);
				$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
				if($auto_convert){
					$credit = $settings['credit_convert'] * $total_fee;
					$db->query_unbuffered("update {$tpf}users set credit=credit+$credit where userid='$pd_uid' limit 1");
				}else{
					$db->query_unbuffered("update {$tpf}users set wealth=wealth+$total_fee where userid='$pd_uid' limit 1");
				}
				
				$s_title = $lang['pay_success'];
				$msg = $lang['your_order'].': '.$out_trade_no.','.$lang['pay_success'];
			}
		
		}else {
			$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$out_trade_no' and pay_method='$action' and userid='$pd_uid'");
			if($rs['total']){
				$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
			}else{
				$ins = array(
					'pay_method' => $action,
					'userid' => $pd_uid,
					'order_number' => $db->escape($out_trade_no),
					'total_fee' => $total_fee,
					'pay_status' => 'fail',
					'in_time' => $timestamp,
					'ip' => $onlineip,
				);
				$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
				
				$s_title = $lang['pay_fail'];
				$msg = $lang['your_order'].': '.$out_trade_no.','.$lang['pay_fail'];
			}
		}
		require_once template_echo('pd_payment',TPL_NAME);
	break;
	
	case 'tenpay':
		include_once PD_PLUGINS_DIR."payment/tenpay/PayResponseHandler.class.php";
		
		$key = $settings['ten_key'];
		$resHandler = new PayResponseHandler();
		$resHandler->setKey($key);
		
		if($resHandler->isTenpaySign()) {
			$transaction_id = $resHandler->getParameter("transaction_id");
			$total_fee = $resHandler->getParameter("total_fee");
			$total_fee = round($total_fee/100,2);
			$pay_result = $resHandler->getParameter("pay_result");
			
			if( "0" == $pay_result ) {
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$transaction_id' and pay_method='$action' and userid='$pd_uid'");
				if($rs['total']){
					$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
				}else{
					$ins = array(
						'pay_method' => 'tenpay',
						'userid' => $pd_uid,
						'order_number' => $db->escape($transaction_id),
						'total_fee' => $total_fee,
						'pay_status' => 'success',
						'in_time' => $timestamp,
						'ip' => $onlineip,
					);
					$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
					
					if($auto_convert){
						$credit = $settings['credit_convert'] * $total_fee;
						$db->query_unbuffered("update {$tpf}users set credit=credit+$credit where userid='$pd_uid' limit 1");
					}else{
						$db->query_unbuffered("update {$tpf}users set wealth=wealth+$total_fee where userid='$pd_uid' limit 1");
					}
					$s_title = $lang['pay_success'];
					$msg = $lang['your_order'].': '.$transaction_id.','.$lang['pay_success'];
				}
				unset($rs);
			} else {
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$transaction_id' and pay_method='$action' and userid='$pd_uid'");
				if($rs['total']){
					$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
				}else{
					$ins = array(
						'pay_method' => 'tenpay',
						'userid' => $pd_uid,
						'order_number' => $db->escape($transaction_id),
						'total_fee' => $total_fee,
						'pay_status' => 'fail',
						'retcode' => $retcode,
						'in_time' => $timestamp,
						'ip' => $onlineip,
					);
					$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
					$s_title = $lang['pay_fail'];
					$msg = $lang['your_order'].': '.$transaction_id.','.$lang['pay_fail'];
				}	
			}
		} else {
			$msg = '<span class="txtred">'.$lang['sign_pay_error'].'</span>';
		}
		require_once template_echo('pd_payment',TPL_NAME);
	break;	
	
	case 'chinabank':
		$key = $settings['chinabank_key'];	//登陆后在上面的导航栏里可能找到“B2C”，在二级导航栏里有“MD5密钥设置”
			
		$v_oid     =trim($_POST['v_oid']);       // 商户发送的v_oid定单编号   
		$v_pmode   =trim($_POST['v_pmode']);    // 支付方式（字符串）   
		$v_pstatus =trim($_POST['v_pstatus']);   //  支付状态 ：20（支付成功）；30（支付失败）
		$v_pstring =trim($_POST['v_pstring']);   // 支付结果信息 ： 支付完成（当v_pstatus=20时）；失败原因（当v_pstatus=30时,字符串）； 
		$v_amount  =trim($_POST['v_amount']);     // 订单实际支付金额
		$v_moneytype =trim($_POST['v_moneytype']); //订单实际支付币种    
		$remark1   =trim($_POST['remark1']);      //备注字段1
		$remark2   =trim($_POST['remark2']);     //备注字段2
		$v_md5str  =trim($_POST['v_md5str']);   //拼凑后的MD5校验值  
		
		$md5string=strtoupper(md5($v_oid.$v_pstatus.$v_amount.$v_moneytype.$key));
		
		if ($v_md5str==$md5string){
			if($v_pstatus=="20"){
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$v_oid' and pay_method='$action' and userid='$pd_uid'");
				if($rs['total']){
					$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
				}else{
					$ins = array(
						'pay_method' => $action,
						'userid' => $pd_uid,
						'order_number' => $db->escape($v_oid),
						'total_fee' => $v_amount,
						'pay_status' => 'success',
						'in_time' => $timestamp,
						'ip' => $onlineip,
					);
					$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
					if($auto_convert){
						$credit = $settings['credit_convert'] * $v_amount;
						$db->query_unbuffered("update {$tpf}users set credit=credit+$credit where userid='$pd_uid' limit 1");
					}else{
						$db->query_unbuffered("update {$tpf}users set wealth=wealth+$v_amount where userid='$pd_uid' limit 1");
					}
					
					$s_title = $lang['pay_success'];
					$msg = $lang['your_order'].': '.$v_oid.','.$lang['pay_success'];
				}
			}else{
				$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$v_oid' and pay_method='$action' and userid='$pd_uid'");
				if($rs['total']){
					$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
				}else{
					$ins = array(
						'pay_method' => $action,
						'userid' => $pd_uid,
						'order_number' => $db->escape($v_oid),
						'total_fee' => $v_amount,
						'pay_status' => 'fail',
						'in_time' => $timestamp,
						'ip' => $onlineip,
					);
					$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
					
					$s_title = $lang['pay_fail'];
					$msg = $lang['your_order'].': '.$v_oid.','.$lang['pay_fail'];
				}
			}
		}else{
			echo $lang['sign_pay_error'];					   
		}
		require_once template_echo('pd_payment',TPL_NAME);
	break;
	
	case 'yeepay':
		include_once PD_PLUGINS_DIR.'payment/yeepay/yeepayCommon.php';	
			
		#	只有支付成功时易宝支付才会通知商户.
		##支付成功回调有两次，都会通知到在线支付请求参数中的p8_Url上：浏览器重定向;服务器点对点通讯.
		
		#	解析返回参数.
		$return = getCallBackValue($r0_Cmd,$r1_Code,$r2_TrxId,$r3_Amt,$r4_Cur,$r5_Pid,$r6_Order,$r7_Uid,$r8_MP,$r9_BType,$hmac);
		
		#	判断返回签名是否正确（True/False）
		$bRet = CheckHmac($r0_Cmd,$r1_Code,$r2_TrxId,$r3_Amt,$r4_Cur,$r5_Pid,$r6_Order,$r7_Uid,$r8_MP,$r9_BType,$hmac);
		#	以上代码和变量不需要修改.
				
		#	校验码正确.
		if($bRet){
			if($r1_Code=="1"){
				
			#	需要比较返回的金额与商家数据库中订单的金额是否相等，只有相等的情况下才认为是交易成功.
			#	并且需要对返回的处理进行事务控制，进行记录的排它性处理，在接收到支付结果通知后，判断是否进行过业务逻辑处理，不要重复进行业务逻辑处理，防止对同一条交易重复发货的情况发生.      	  	
				
				if($r9_BType=="1"){
					echo "交易成功";
					echo  "<br />在线支付页面返回";
				}elseif($r9_BType=="2"){
					$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$r6_Order' and pay_method='$action' and userid='$pd_uid'");
					if($rs['total']){
						$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
					}else{
						$ins = array(
							'pay_method' => $action,
							'userid' => $pd_uid,
							'order_number' => $db->escape($r6_Order),
							'total_fee' => $r3_Amt,
							'pay_status' => 'success',
							'in_time' => $timestamp,
							'ip' => $onlineip,
						);
						$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
						if($auto_convert){
							$credit = $settings['credit_convert'] * $r3_Amt;
							$db->query_unbuffered("update {$tpf}users set credit=credit+$credit where userid='$pd_uid' limit 1");
						}else{
							$db->query_unbuffered("update {$tpf}users set wealth=wealth+$r3_Amt where userid='$pd_uid' limit 1");
						}
						
						$s_title = $lang['pay_success'];
						$msg = $lang['your_order'].': '.$r6_Order.','.$lang['pay_success'];
					}
				}else{
					$rs = $db->fetch_one_array("select count(*) as total from {$tpf}orders where order_number='$r6_Order' and pay_method='$action' and userid='$pd_uid'");
					if($rs['total']){
						$msg = '<span class="txtblue">'.$lang['pay_order_exists'].'</span>';
					}else{
						$ins = array(
							'pay_method' => $action,
							'userid' => $pd_uid,
							'order_number' => $db->escape($r6_Order),
							'total_fee' => $r3_Amt,
							'pay_status' => 'fail',
							'in_time' => $timestamp,
							'ip' => $onlineip,
						);
						$db->query("insert into {$tpf}orders set ".$db->sql_array($ins).";");
						
						$s_title = $lang['pay_fail'];
						$msg = $lang['your_order'].': '.$r6_Order.','.$lang['pay_fail'];
					}
				}
			}
			
		}else{
			echo $lang['sign_pay_error'];
		}
   		require_once template_echo('pd_payment',TPL_NAME);
	break;
	
	default:
		redirect('./','');
}
include PHPDISK_ROOT."./includes/footer.inc.php";

?>