<?php 
##
#	Project: PHPDISK File Storage Solution
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: admin.inc.php 481 2010-10-22 01:52:32Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK') || !defined('IN_ADMINCP')) {
	exit('[PHPDisk] Access Denied');
}
phpdisk_admin();

check_plugin_active_status($app);

require_once "{$app}.lang.php";

$lang = array_merge($pub_lang,$lang);

switch($action){
	case 'index':
		
		if($task =='update'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$email_pwd_src = trim($settings['email_pwd']);
			$setting = array(
				'open_email' => 0,
				'email_address' => '',
				'email_user' => '',
				'email_pwd' => '',
				'email_smtp' => '',
				'email_port' => '',
				'email_ssl' => 0,
			);
			$online_demo = $settings['online_demo'];
			$settings = gpc('setting','P',$setting);

			if($online_demo){
				$error = true;
				$sysmsg[] = $lang['online_demo_deny'];
			}
			if(!checkemail($settings['email_address'])){
				$error = true;
				$sysmsg[] = $lang['email_address_error'];
			}
			if(checklength($settings['email_user'],2,30)){
				$error = true;
				$sysmsg[] = $lang['email_user_error'];
			}
			if(strpos($settings['email_pwd'],'*') ===false){
				if(checklength($settings['email_pwd'],2,20)){
					$error = true;
					$sysmsg[] = $lang['email_pwd_error'];
				}
			}else{
				$settings['email_pwd'] = $email_pwd_src;
			}
			if(checklength($settings['email_smtp'],6,50)){
				$error = true;
				$sysmsg[] = $lang['email_smtp_error'];
			}
			if(!$settings['email_port']){
				$error = true;
				$sysmsg[] = $lang['email_port_error'];
			}else{
				$settings['email_port'] = (int)$settings['email_port'];
			}
			if(!$error){
				
				settings_cache($settings);
				
				$sysmsg[] = $lang['email_update_success'];
				redirect(urr("admincp","item=plugins&app=$app&action=index"),$sysmsg);
				
			}else{
				redirect('back',$sysmsg);
			}
			
		}elseif($task =='mail_test'){
			if($p_formhash != formhash()){
				exit($lang['system_error']);
			}
			$receive_address = trim(gpc('receive_address','P',''));
			$mail_subject = trim(gpc('mail_subject','P',''));
			$mail_content = trim(gpc('mail_content','P',''));
			
			if(!checkemail($receive_address)){
				$error = true;
				$sysmsg[] = $lang['email_address_error'];
			}
			if(checklength($mail_subject,2,80)){
				$error = true;
				$sysmsg[] = $lang['email_subject_error'];
			}
			if(checklength($mail_content,2,250)){
				$error = true;
				$sysmsg[] = $lang['email_content_error'];
			}
			if(!$error){
				$to = $receive_address;
				$subject = $mail_subject;
				$body = $mail_content;
				$from = $sender = $username = $settings['email_address'];
				$fromname = $settings['email_user'];
				$host = $settings['email_smtp'];
				$port = (int)$settings['email_port'];
				$ssl = (int)$settings['email_ssl'];
				$password = $settings['email_pwd'];

				send_email($to,$subject,$body,$from,$fromname,$stmp = true, $sender,$host,$port,$ssl,$username,$password);
				$sysmsg[] = $lang['send_email_success'];
				redirect(urr("admincp","item=plugins&app=$app&action=index"),$sysmsg);
				
			}else{
				redirect('back',$sysmsg);
			}
			
		}else{
			$setting = $settings;
			$setting['email_pwd'] = encode_pwd($setting['email_pwd']);
			require_once template_echo('admin','',$app);
		}	
	break;
	
	default:
		redirect(urr("admincp","item=plugins&app=$app&action=index"),'',0);
}
update_action_time($app);
?>